#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x3c, 20, 2); // set the LCD address to 0x27 for a 16 chars and 2 line display

#include <Keypad.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

const byte ROWS = 4;
const byte COLS = 3;

char keys [ROWS] [COLS] = {
  {'1', '2', '3'},
  {'4', '5', '6'},
  {'7', '8', '9'},
  {'C', '0', '='}
};
byte rowPins[ROWS] = {15, 14, 27, 26};
byte colPins[COLS] = {25, 33, 32};

Keypad myKeypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );


boolean presentValue = false;
boolean next = false;
boolean final = false;
String num1, num2;
int answer = 0;
char op;
String num3;

void setup()
{
  Serial.begin(9600);
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { 
    Serial.println(F("SSD1306 allocation failed"));
    for(;;); // Don't proceed, loop forever
  }
  display.display();
  delay(2000); // Pause for 2 seconds

  // Clear the buffer
  display.clearDisplay();
  display.display();

}
void loop() {
  //Serial.println("Maker UNO");
  char key = myKeypad.getKey();
  if(num3 == NULL){
  num3 = String(Serial.read());
  }
  if (key != NO_KEY && (key == '1' || key == '2' || key == '3' || key == '4' || key == '5' || key == '6' || key == '7' || key == '8' || key == '9' || key == '0'))
  {
    if (presentValue != true)
    {
      num1 = num1 + key;
      int numLength = num1.length();
      display.setCursor(0, 0);
      String String_num1 = String(num1);
      display.setTextSize(2);
      display.setTextColor(WHITE);        
      display.println(String_num1);
      display.display();
    }
    else
    {
      num2 = num2 + key;
      int numLength = num2.length();
      int numLength1 = num1.length();
      display.setCursor(1 + numLength1, 0);
      String String_num2 = String(num2);
      display.setTextSize(2);
      display.setTextColor(WHITE);  
      display.println(num2);
      display.display();
      final = true;
    }
  }

 
  else if (key != NO_KEY && key == 'C') {
    display.clearDisplay();
    display.display();
    presentValue = false;
    final = false;
    num1 = "";
    num2 = "";
    answer = 0;
    op = ' ';
  }
   else if (key != NO_KEY && key == '=') {
    
    display.clearDisplay();
    display.display();
    Serial.print(num3);
    Serial.print("/n");
    Serial.print(num1);
    if(num3==num1){
      display.println("Correct");
      display.display();
    }
    else if(num3 != num1){
      display.println("You so stpid");
      display.display();
     
    }
    presentValue = false;
    final = false;
    num1 = "";
    num2 = "";
    answer = 0;
    op = ' ';
}
}
